public inbox for isar-users@googlegroups.com
 help / color / mirror / Atom feed
From: Jan Kiszka <jan.kiszka@siemens.com>
To: isar-users <isar-users@googlegroups.com>
Cc: Quirin Gylstorff <quirin.gylstorff@siemens.com>
Subject: [PATCH 16/17] meta-isar: deploy-image: Introduce auto-installation mode
Date: Tue,  2 Jul 2024 15:38:30 +0200	[thread overview]
Message-ID: <d8ef1780acd5729089b65f36902f17f8dfb4fc3c.1719927511.git.jan.kiszka@siemens.com> (raw)
In-Reply-To: <cover.1719927511.git.jan.kiszka@siemens.com>

From: Jan Kiszka <jan.kiszka@siemens.com>

If a special file called auto.install is found in the installation data
directory, parse this and attempt an unattended installation. The file
consists of 2 to 3 lines:

- source file name
- target device path
- optionally, "OVERWRITE" to ignore if the target device is non-empty

e.g.:
$ cat /install/auto.install
isar-image-base-debian-bookworm-qemuamd64.wic.zst
/dev/vda
OVERWRITE

Errors are still stopping the process, switching it back to interactive
mode.

Signed-off-by: Jan Kiszka <jan.kiszka@siemens.com>
---
 .../deploy-image/files/deploy-image-wic.sh       | 16 ++++++++++++++--
 1 file changed, 14 insertions(+), 2 deletions(-)

diff --git a/meta-isar/recipes-installer/deploy-image/files/deploy-image-wic.sh b/meta-isar/recipes-installer/deploy-image/files/deploy-image-wic.sh
index 9df93fe7..8b25b1d2 100644
--- a/meta-isar/recipes-installer/deploy-image/files/deploy-image-wic.sh
+++ b/meta-isar/recipes-installer/deploy-image/files/deploy-image-wic.sh
@@ -7,8 +7,20 @@
 installdata=${INSTALL_DATA:-/install}
 
 AUTO_INSTALL=false
+OVERWRITE=
 
-if ! $AUTO_INSTALL; then
+if [ -f "$installdata/auto.install" ]; then
+    exec 3<"$installdata/auto.install"
+    read -r DISK_IMAGE <&3
+    read -r TARGET_DEVICE <&3
+    read -r OVERWRITE <&3
+    exec 3>&-
+    if [ ! -b ${TARGET_DEVICE} ]; then
+        dialog --msgbox "Target device is not a valid block device. Installation aborted." 6 60
+        exit 1
+    fi
+    AUTO_INSTALL=true
+else
     DISK_IMAGE=$(find "$installdata" -type f -iname "*.wic*" -a -not -iname "*.wic.bmap" -exec basename {} \;)
     if [ -z "$DISK_IMAGE" ] || [ ! -f "$installdata/$DISK_IMAGE" ]; then
         pushd "$installdata"
@@ -110,7 +122,7 @@ if ! $AUTO_INSTALL; then
     fi
 fi
 
-if ! cmp /dev/zero "$TARGET_DEVICE" -n 1M && \
+if [ "$OVERWRITE" != "OVERWRITE" ] && ! cmp /dev/zero "$TARGET_DEVICE" -n 1M && \
    ! dialog --defaultno \
             --yesno "WARNING: Target device is not empty! Continue anyway?" 5 60; then
     exit 0
-- 
2.43.0


  parent reply	other threads:[~2024-07-02 13:38 UTC|newest]

Thread overview: 30+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2024-07-02 13:38 [PATCH 00/17] Reworks, fixes and unattended mode for image installer Jan Kiszka
2024-07-02 13:38 ` [PATCH 01/17] Kconfig: Rework installer image submenu Jan Kiszka
2024-07-02 13:38 ` [PATCH 02/17] installer: Do not show systemd boot menu Jan Kiszka
2024-07-02 13:38 ` [PATCH 03/17] meta-isar: deploy-image: Change reboot logic Jan Kiszka
2025-03-13 13:10   ` Uladzimir Bely
2025-03-14  5:54     ` 'Jan Kiszka' via isar-users
2025-03-14  6:25       ` Uladzimir Bely
2025-03-14 14:25         ` 'Heinisch, Alexander' via isar-users
2025-03-14 15:04           ` Uladzimir Bely
2024-07-02 13:38 ` [PATCH 04/17] meta-isar: deploy-image: Drop umount attempt after installation Jan Kiszka
2024-07-02 13:38 ` [PATCH 05/17] meta-isar: deploy-image: Fix bmap support Jan Kiszka
2024-07-02 13:38 ` [PATCH 06/17] meta-isar: deploy-image: Improve root mountpoint discovery Jan Kiszka
2024-07-02 13:38 ` [PATCH 07/17] meta-isar: deploy-image: Make TARGET_DEVICE a complete path Jan Kiszka
2024-07-02 13:38 ` [PATCH 08/17] meta-isar: deploy-image: Drop pointless --clear options from dialog Jan Kiszka
2024-07-02 13:38 ` [PATCH 09/17] meta-isar: deploy-image: Allow to cancel installation Jan Kiszka
2024-07-02 13:38 ` [PATCH 10/17] meta-isar: deploy-image: Warn if overwriting a non-empty disk Jan Kiszka
2024-07-03 15:53   ` 'MOESSBAUER, Felix' via isar-users
2024-07-03 15:55     ` 'Jan Kiszka' via isar-users
2024-07-19  5:33       ` Uladzimir Bely
2024-07-19  5:44         ` 'Jan Kiszka' via isar-users
2024-07-02 13:38 ` [PATCH 11/17] meta-isar: deploy-image: Fix and enhance image selection dialog Jan Kiszka
2024-07-02 13:38 ` [PATCH 12/17] meta-isar: deploy-image: Improve target device list dialog Jan Kiszka
2024-07-02 13:38 ` [PATCH 13/17] meta-isar: deploy-image: Polish some dialogs Jan Kiszka
2024-07-02 13:38 ` [PATCH 14/17] meta-isar: deploy-image: Re-indent Jan Kiszka
2024-07-02 13:38 ` [PATCH 15/17] meta-isar: deploy-image: Prepare for auto-installation mode Jan Kiszka
2024-07-02 13:38 ` Jan Kiszka [this message]
2024-07-03 15:56   ` [PATCH 16/17] meta-isar: deploy-image: Introduce " 'MOESSBAUER, Felix' via isar-users
2024-07-03 16:08     ` 'Jan Kiszka' via isar-users
2024-07-02 13:38 ` [PATCH 17/17] meta-isar: deploy-image: Polish recipe Jan Kiszka
2024-07-23  7:40 ` [PATCH 00/17] Reworks, fixes and unattended mode for image installer Uladzimir Bely

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=d8ef1780acd5729089b65f36902f17f8dfb4fc3c.1719927511.git.jan.kiszka@siemens.com \
    --to=jan.kiszka@siemens.com \
    --cc=isar-users@googlegroups.com \
    --cc=quirin.gylstorff@siemens.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox